#pragma once
#include "PGJsonObject.h"

//-----------------------------------------------------------------------------
/**
@brief グリッド JSON オブジェクト

グリッドの JSON オブジェクトデータを保持します。
*/
class PGJsonGrid : public PGJsonObject
{
  public:
	PGJsonGrid(PGJsonObject* parent);

	virtual ostream& OutJsonMember( ostream &out, int &b ); // const
	virtual ostream& OutJsonDirtyMember( ostream &out, int &b );
	
	typedef vector<PGValue> ValueList;                   ///< @brief 値リスト型
	typedef vector<PGValue>::iterator ValueIterator;     ///< @brief @ref ValuList のイテレーター型 
	typedef vector<ValueList> DataList;                  ///< @brief @ref ValuList リスト型
	typedef vector<ValueList>::iterator DataIterator;    ///< @brief @ref DataList のイテレーター型
	typedef vector<PGJsonObject> HeadList;               ///< @brief @ref JSON オブジェクトリスト型
	typedef vector<PGJsonObject>::iterator HeadIterator; ///< @brief @ref HeadList のイテレーター型
	
	ostream &OutJsonData( ostream &out, int &b );
	ostream &OutJsonHead( ostream &out, int &b );
	void SetDataSize( int x, int y );
	void SetData( int x, int y ,const char* data);
	SGString GetData( int x, int y);
//	void SetHeadSize( int x );
private:
	DataList mData; ///< @brief 値の二次元リスト
//	HeadList mHead; ///< @brief JSON オブジェクトリスト
};

